package com.sales;

import java.io.IOException;
import java.util.Arrays;
import java.util.List;

import org.apache.hadoop.io.DoubleWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Mapper;

public final class SalesMapper extends Mapper<LongWritable, Text, Text, DoubleWritable>
{
	private final Text category = new Text();
	public final void map(final LongWritable key, final Text value, final Context context) throws IOException, InterruptedException
	{
		final String line = value.toString();	
//		AVphzgbJLJeJML43fA0o	104.99	104.99	Yes	USD	2017-03-30T06:00:00Z,2017-03-10T22:00:00Z,2017-03-04T10:00:00Z,2017-03-03T14:00:00Z	Bestbuy.com	B00C78VIUE	Sanus	Audio & Video Accessories,TV Mounts,TV Accessories & Parts,Electronics,A/V Presentation,Accessories & Supplies,TV Ceiling & Wall Mounts	2015-04-13T12:00:51Z	2018-05-12T18:59:48Z	https://images-na.ssl-images-amazon.com/images/I/71oVh2UO8xL._SL1500_.jpg,http://pisces.bbystatic.com/image2/BestBuy_US/images/products/5689/5689019_sa.jpg,https://images-na.ssl-images-amazon.com/images/I/81EzIaCamJL._SL1500_.jpg,https://images-na.ssl-images-amazon.com/images/I/71X2tAW39aL._SL1500_.jpg,https://images-na.ssl-images-amazon.com/images/I/71c8xybNthL._SL1500_.jpg,http://static.bhphoto.com/images/smallimages/1368452917000_911749.jpg,http://static.bhphoto.com/images/images500x500/sanus_vlf410_b1_vlf410_super_slim_full_motion_1368452917000_911749.jpg,http://static.bhphoto.com/images/multiple_images/thumbnails/1368452838000_IMG_316474.jpg		VLF410B1	Sanus VLF410B1 10-Inch Super Slim Full-Motion Mount for 37 - 84 Inches TV's	Electronics	32.8 pounds

		final String[] data = line.trim().split("\t");
		//data[0]= id					A
		//data[1]= prices.amountMax		B
		//data[2]= prices.amountMin		C
		//data[3]= prices.availability	D

		//data[4]= prices.currency		F
		//data[5]= prices.dateSeen		G

		//data[6]= prices.merchant		I

		//data[7]= asins				L
		//data[8]= brand				M
		//data[9]= categories			N
		//data[10]= dateAdded			O
		//data[11]= dateUpdated			P

		//data[12]= imageURLs			R

		//data[13]= manufacturer		T
		//data[14]= manufacturerNumber	U
		//data[15]= name				V
		//data[16]= primaryCategories	W

		//data[17]= weight				Z

		String slist[] = { "ASUS","APPLE","DELL","LENOVO","SAMSUNG","SONY","TOSHIBA" };
		List<String> list = Arrays.asList(slist);

		if (data.length == 18)
		{
			if(list.contains(String.valueOf(data[8]).toUpperCase())) {
				final String brand = data[8];
				final double amountMax = Double.parseDouble(data[1]);
				category.set(brand);
				context.write(category, new DoubleWritable(amountMax));
			}

//			if(list.stream().anyMatch(data[8]::equalsIgnoreCase)) {
////				System.out.println("data[8]: " + data[8] + " | data[1]: " + data[1]);
//				final String brand = data[8];
//				final double amountMax = Double.parseDouble(data[1]);
//				category.set(brand);
//				context.write(category, new DoubleWritable(amountMax));
////				(ASUS,202.12) 	output to reducer
//			}
		}
	}
}